#ifndef SPI_ASM_Class_Defined__
#define SPI_ASM_Class_Defined__

#include <stdint.h>

class SPI_ASM {
public:
  static const int Msbpre = 0;
  static const int Lsbpre = 1;
  static const int Msbpost = 2;
  static const int Lsbpost = 3;
  static const int Lsbfirst = 4;
  static const int Msbfirst = 5;
  static const int _shiftout = 1;
  static const int _shiftin = 2;
  static uint8_t dat[];
  int32_t	Shiftout(int32_t Dpin, int32_t Cpin, int32_t Mode, int32_t Bits, int32_t Value);
  int32_t	Shiftin(int32_t Dpin, int32_t Cpin, int32_t Mode, int32_t Bits);
  int32_t	Start(int32_t Delay, int32_t State);
  int32_t	Stop(void);
private:
  int32_t	Cog, Command;
  int32_t	Setcommand(int32_t Cmd, int32_t Argptr);
};

#endif
