#ifndef touchSpin_Class_Defined__
#define touchSpin_Class_Defined__

#include <stdint.h>
#include "SPI_ASM.h"
#include "SD-MMC_FATEngine.h"

class touchSpin {
public:
  static const int Touch = 0;
  static const int Margin = 4;
  static const int _1ms = 1000;
  static const int Touch_clock = 0;
  static const int Touch_datain = 1;
  static const int Touch_dataout = 2;
  static const int _dopin = 24;
  static const int _clkpin = 25;
  static const int _dipin = 26;
  static const int _cspin = 27;
  static const int _cdpin = -1;
  static const int _wppin = -1;
  static const int _rtcres1 = -1;
  static const int _rtcres2 = -1;
  static const int _rtcres3 = -1;
  static const int _statuspin = -1;
  static const int Scl = 28;
  static const int Sda = 29;
  SPI_ASM	Spi;
  SD_MMC_FATEngine	Fat;
  static uint8_t dat[];
  int32_t	Begindesktop(int32_t Displaytype);
  int32_t	Beginprogram(void);
  int32_t	Stringtest(void);
  int32_t	Stringdim(int32_t N);
  int32_t	Stringstore(int32_t Stringn, int32_t Source);
  int32_t	Stringdebug(int32_t Stringn);
  int32_t	Stringclear(int32_t Stringn);
  int32_t	Stringaddchar(int32_t Stringn, int32_t C);
  int32_t	Stringsubchar(int32_t Stringn);
  int32_t	Stringcopy(int32_t Dest, int32_t Source);
  int32_t	Stringleft(int32_t Dest, int32_t Source, int32_t N);
  int32_t	Stringmid(int32_t Dest, int32_t Source, int32_t Start, int32_t N);
  int32_t	Stringright(int32_t Dest, int32_t Source, int32_t N);
  int32_t	Stringinstr(int32_t Source, int32_t Start, int32_t C);
  int32_t	Stringbin(int32_t Dest, int32_t N);
  int32_t	Stringhex(int32_t Dest, int32_t N);
  int32_t	Stringdec(int32_t Dest, int32_t N);
  int32_t	Stringstr(int32_t Dest, int32_t N);
  int32_t	Stringval(int32_t Source);
  int32_t	Stringjoin(int32_t Dest, int32_t Source1, int32_t Source2);
  int32_t	Stringucase(int32_t Dest, int32_t Source);
  int32_t	Stringlcase(int32_t Dest, int32_t Source);
  int32_t	Stringtrim(int32_t Dest, int32_t Source);
  int32_t	Stringsavefile(int32_t Filen, int32_t Start, int32_t Finish);
  int32_t	Stringloadfile(int32_t Filen, int32_t Stringnumber);
  int32_t	Stringlen(int32_t Source);
  int32_t	Stringprint(int32_t Font, int32_t Source);
  int32_t	Stringrambuffer(int32_t Source);
  int32_t	Stringcompare(int32_t Source1, int32_t Source2);
  int32_t	Displayleft(void);
  int32_t	Displayright(void);
  int32_t	Ramerase(int32_t N);
  int32_t	Clearram(void);
  int32_t	Getcurx(void);
  int32_t	Getcury(void);
  int32_t	Setcurx(int32_t N);
  int32_t	Setcury(int32_t N);
  int32_t	Getbackfontcolor(void);
  int32_t	Getramlocation(int32_t N);
  int32_t	Getfilenumber(void);
  int32_t	Setfilenumber(int32_t N);
  int32_t	Chain(int32_t Stringptr);
  int32_t	Sdtoram(int32_t Stringptr);
  int32_t	Fetchrambuffer(void);
  int32_t	Sdbmptoram(int32_t Stringptr);
  int32_t	Drawbmpram(int32_t F, int32_t X, int32_t Y);
  int32_t	Mergebackgroundiconram(int32_t Stringptr, int32_t X, int32_t Y, int32_t Desktop, int32_t Mask, int32_t Icon);
  int32_t	Openfileread(int32_t Stringptr);
  int32_t	Fileclose(void);
  int32_t	Touchxpercent(void);
  int32_t	Touchypercent(void);
  int32_t	Touchswishx(void);
  int32_t	Touchswishy(void);
  int32_t	Touchstart(void);
  int32_t	Textchar(int32_t Filen, int32_t Ascii, int32_t X, int32_t Y);
  int32_t	Crlf(void);
  int32_t	Cr(void);
  int32_t	Lf(void);
  int32_t	Textt(int32_t Filen, int32_t Stringptr);
  int32_t	Setcursor(int32_t X, int32_t Y);
  int32_t	Readramlong(int32_t Wordstart, int32_t Bytevalue);
  int32_t	Loadfont(int32_t Stringptr);
  int32_t	Hubtoram(int32_t Ramaddress, int32_t Number);
  int32_t	Ramtohub(int32_t Ramaddress, int32_t Number);
  int32_t	Ramtodisplay(int32_t Ramaddress, int32_t Number);
  int32_t	Clearscreen(int32_t Color);
  int32_t	Rgbtoword(int32_t R, int32_t G, int32_t B);
  int32_t	Clearrectangle(int32_t X1, int32_t Y1, int32_t X2, int32_t Y2, int32_t Colorword);
  int32_t	Drawline(int32_t X1, int32_t Y1, int32_t X2, int32_t Y2, int32_t Colorword);
  int32_t	Setorientation(int32_t E);
  int32_t	Changeorientation(int32_t N);
  int32_t	Selectmemgroup(void);
  int32_t	Selectspigroup(void);
  int32_t	Text(int32_t Stringptr);
  int32_t	Propfontcrlf(void);
  int32_t	Propfont_out(int32_t Ascii);
  int32_t	Start_ili9325(void);
  int32_t	Start_ssd1289(void);
  int32_t	Draw(int32_t X1, int32_t Y1, int32_t X2, int32_t Y2);
  int32_t	Pixel(int32_t Pixelcolor);
  int32_t	Pause1ms(int32_t Period);
  int32_t	Hex(int32_t Value, int32_t Digits);
  int32_t	Setwarmboot(void);
  int32_t	Warmcoldboot(void);
  int32_t	Manualvalues(void);
private:
  uint8_t	Filenumber;
  uint8_t	Displaymode;
  uint16_t	Screenwidth;
  uint16_t	Screenheight;
  int32_t	Orientation;
  int32_t	Curx, Cury;
  uint8_t	Fontheight;
  uint16_t	Backfontcolor;
  uint8_t	Latch;
  int32_t	Stringaddress;
  uint8_t	I2cbyte;
  int32_t	Wcboot;
  int32_t	Command, Hubaddrs, Ramaddrs, Blocklen, Errx, Cog;
  int32_t	Begin(int32_t Desktop);
  int32_t	Stringtoram(int32_t Stringn);
  int32_t	Ramtostring(int32_t Stringn);
  int32_t	Getdisplaymode(void);
  int32_t	I2c_initialize(void);
  int32_t	I2c_start(void);
  int32_t	I2c_stop(void);
  int32_t	I2c_write(int32_t Data);
  int32_t	I2c_writelocation(int32_t Device_address, int32_t Register, int32_t Value);
  int32_t	Mcp23008_write(void);
  int32_t	Mcpgroup0(void);
  int32_t	Mcpgroup1(void);
  int32_t	Mcpgroup2(void);
  int32_t	Mcpgroup3(void);
  int32_t	Mcp23008_resetlow(void);
  int32_t	Mcp23008_resethigh(void);
  int32_t	Mcp23008_display1(void);
  int32_t	Mcp23008_display2(void);
  int32_t	Mcp23008_displayboth(void);
  int32_t	Mcp23008_diaglow(void);
  int32_t	Mcp23008_diaghigh(void);
  int32_t	Mcp23008_allhigh(void);
  int32_t	Load161(int32_t Address);
  int32_t	Spinhubtoram(int32_t Hubaddress, int32_t Ramaddress, int32_t Number);
  int32_t	Spinramtohub(int32_t Hubaddress, int32_t Ramaddress, int32_t Number);
  int32_t	Spinramtodisplay(int32_t Ramaddress, int32_t Number);
  int32_t	Spinhubtodisplay(int32_t Hubaddress, int32_t Number);
  int32_t	Nextlocation(void);
  int32_t	Touchx(void);
  int32_t	Touchy(void);
  int32_t	Touchvalue(void);
  int32_t	Ili9325initiate(void);
  int32_t	Ssd1289initiate(void);
  int32_t	Displaycmd(int32_t C, int32_t D);
  int32_t	Lcd_write_com(int32_t Lcdlong);
  int32_t	Lcd_write_data(int32_t Lcdlong);
  int32_t	Lcd_writ_bus(int32_t Lcdlong);
  int32_t	Lcd_rs_low(void);
  int32_t	Lcd_rs_high(void);
  int32_t	Lcd_wr_low(void);
  int32_t	Lcd_wr_high(void);
  int32_t	Lcd_rd_high(void);
  int32_t	Lcd_cs_high(void);
  int32_t	Lcd_cs_low(void);
  int32_t	Lcd_reset_low(void);
  int32_t	Lcd_reset_high(void);
  int32_t	Start_ram_cog(void);
  int32_t	Stop_ram_cog(void);
  int32_t	Cogcmd(int32_t Command_, int32_t Hub_address, int32_t Ram_address, int32_t Block_length);
};

#endif
